#ifndef ___PNL_MPIWRAP
#define ___PNL_MPIWRAP

//#define _MPI

#ifdef _MPI

#include "../../../../mpich/include/mpi.h"
#include "../../../../mpich/include/mpi_errno.h"

// Eric, Apr.6, 2004
#include "../../../../vt/include/VT.h"

#define LOCDEF()  { int loc; VT_scldef( __FILE__, __LINE__, &loc ); VT_thisloc( loc ); }

struct _VT_FuncFrameHandle {
        char *name;
        int func;
        int frame;
};
typedef struct _VT_FuncFrameHandle VT_FuncFrameHandle_t;

#define VT_REGION_DEF( _name, _nameframe, _class ) \
        (_nameframe).name=_name; \
        VT_funcdef( (_nameframe).name, _class, &((_nameframe).func) ); \
        VT_framedef( "communication", VT_CAT_FUNCTIONS|VT_CAT_MESSAGES, VT_FRAME_PROCESS, &((_nameframe).frame) )
#define VT_BEGIN_REGION( _nameframe ) \
        LOCDEF(); \
        VT_framebegin( (_nameframe).name, (_nameframe).frame ); \
        VT_begin( (_nameframe).func )
#define VT_END_REGION( _nameframe ) \
        VT_end( (_nameframe).func ); \
        VT_frameend( (_nameframe).frame )

// End

PNL_API extern int	_my_rank, _num_procs;
PNL_API extern int	_namelen;
PNL_API extern char	_processor_name[MPI_MAX_PROCESSOR_NAME];
PNL_API extern int	_version, _subversion;

PNL_API void pnlMpiInit(int argc, char * argv[]);
PNL_API void pnlMpiFinalize();

#define MPI_REMARK	printf
//#define snprintf	_snprintf
#define MPI_WARNING	printf

char * _RetCode2String(int code);

#define MPI_CALL(Func)                                                          {			                                                          	int _status = Func;			                                     	if (_status != MPI_SUCCESS)		                                    	{					                                       		char _warnMsg[256];		                                   		snprintf(_warnMsg, 255, 	                                		"MPI Function %s failed at %s %d ErrCode (%d): %s\n",				#Func, __FILE__, __LINE__, _status, 			               		_RetCode2String(_status));				              		MPI_WARNING(_warnMsg);					        	}								        }

#endif
#endif
