#ifndef ETI_GREEDY_H
#define ETI_GREEDY_H

#include <vector>
#include "Bitmap.h"
#include "DataSet.h"

class ETIGreedy
{
 public:
  ETIGreedy(DataSet *data, double epsc, double epsr, int minsup);

  bool FindSomeETIs(int lambda);
  void MineETIs();

 private:  
  DataSet *dataSet;
  double epsCol;
  double epsRow;
  int minSup;
  int epsPP;
  int *pruningSupport;
  vector<Bitmap> etis;

	bool HasStrongSupport(Bitmap items);

  double ComputeSigma(Bitmap *indices, int *zeros, int lambda, bool debug);
  bool AddETIToList(Bitmap items);
  void PrintItems(Bitmap *items);
  void ComputePruningSupport();
  void ComputeZeros(Bitmap *indices, int *zeros, int *count);
  void ComputeZeros(Bitmap *indices, int *zeros);
  int SupportCount(int *zeros, int items);
  double ComputeCoverage(Bitmap *items, int item, int *zeros);
};

#endif
