#ifndef ____CHECKCOV__FANCTORS
#define ____CHECKCOV__FANCTORS

#include "likelihoodComputation.h"
using namespace likelihoodComputation;

#include "definitions.h"
#include "sequenceContainer.h"
#include "treeInterface.h"
#include "stochasticProcess.h"
using namespace treeInterface;

#ifdef VERBOS
#include <iostream>
using namespace std;
#endif

class Cevaluate_L_given_r{
public:
  explicit Cevaluate_L_given_r(	const sequenceContainer& sd,
								const tree& t1,
								const stochasticProcess& sp,
								const int pos)
			:_sd(sd), _t1(t1), _pos(pos), _sp(sp){}
private:
	const sequenceContainer& _sd;
	const tree& _t1;
	const int _pos;
	const stochasticProcess& _sp;
public:
	MDOUBLE operator() (const MDOUBLE r) {
		
		MDOUBLE tmp1= getLofPos(_pos,_t1,_sd,_sp,r);
		#ifdef VERBOS
			cerr<<" r = "<<r<<" l = "<<tmp1<<endl;
		#endif
		return -tmp1;
	}
};

// WHEN YOU WANT TWO TREE TO HAVE THE SAME RATE AT A SPECIFIC POSITION.
class Cevaluate_L_sum_given_r{
public:
	explicit Cevaluate_L_sum_given_r(const stochasticProcess& sp,
									 const sequenceContainer1G& sd,
									 const tree &inLTree1,
									 const tree &inLTree2,
									 const int pos)
			:_sp(sp), _sd(sd), _tree1(inLTree1),_tree2(inLTree2), _pos(pos){};

private:
	const stochasticProcess _sp;
	const sequenceContainer1G _sd;
	const tree& _tree1;
	const tree& _tree2;
	const int _pos;
public:
	MDOUBLE operator() (const MDOUBLE r) {
		MDOUBLE tmp1= getLofPos(_pos,_tree1,_sd,_sp,r);
		MDOUBLE tmp2= getLofPos(_pos,_tree2,_sd,_sp,r);
		MDOUBLE tmp= tmp1*tmp2;
		return -tmp;
	}
};

#endif
