/* cmdline.h */

/* File autogenerated by gengetopt version 2.7  */

#ifndef _cmdline_h
#define _cmdline_h

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* Don't define PACKAGE and VERSION if we use automake.  */
#ifndef PACKAGE
#define PACKAGE "semphy"
#endif

#ifndef VERSION
#define VERSION "1.0.a4"
#endif

struct gengetopt_args_info
{
  char * sequence_arg;	/* Sequence file name (default='-').  */
  char * format_arg;	/* sequence format: [phylip],clustal,molphy,mase,fasta (default='phylip').  */
  char * tree_arg;	/* Tree file name.  */
  char * outputfile_arg;	/* Output tree file (default='-').  */
  int verbose_arg;	/* Log report level (verbose) (default=0).  */
  char * Logfile_arg;	/* Log file output name (default='-').  */
  int alphabet_arg;	/* Alphabet Size (default=20).  */
  char * model_arg;	/* model type: day,[jtt],rev,wag,cprev,nucjc,aaJC,k2p,file:<USERFILE> (default='jtt').  */
  float ratio_arg;	/* transition transversion ratio (default=2).  */
  char * ACGprob_arg;	/* comma separated NA prior list for hky model- A,C,G (default='0.25,0.25,0.25').  */
  float gamma_arg;	/* use gamma and set alpha (default=0.3).  */
  int no_SEMPHY_flag;	/* Don't do SEMPHY step (default=off).  */
  int gaps_flag;	/* Remove positions with gaps (default=off).  */
  int no_bbl_flag;	/* Do not do best branch length step (default=on).  */
  int exact_flag;	/* Compute exact counts (default=off).  */
  int max_semphy_iterations_arg;	/* Max number of SEM iterations (default=100).  */
  int max_bbl_iterations_arg;	/* Max number of BBL iterations (default=1000).  */
  int dont_use_NJ_flag;	/* Do not Use NJ to break start in REART (default=on).  */
  float minimum_improvement_arg;	/* Minimum improvement (default=0.001).  */
  float maxDistance_arg;	/* 'infinity' distance for sequance pairs (default=2).  */
  long seed_arg;	/* Seed random number generator.  */

  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int sequence_given ;	/* Whether sequence was given.  */
  int format_given ;	/* Whether format was given.  */
  int tree_given ;	/* Whether tree was given.  */
  int outputfile_given ;	/* Whether outputfile was given.  */
  int verbose_given ;	/* Whether verbose was given.  */
  int Logfile_given ;	/* Whether Logfile was given.  */
  int alphabet_given ;	/* Whether alphabet was given.  */
  int model_given ;	/* Whether model was given.  */
  int ratio_given ;	/* Whether ratio was given.  */
  int ACGprob_given ;	/* Whether ACGprob was given.  */
  int gamma_given ;	/* Whether gamma was given.  */
  int no_SEMPHY_given ;	/* Whether no-SEMPHY was given.  */
  int gaps_given ;	/* Whether gaps was given.  */
  int no_bbl_given ;	/* Whether no-bbl was given.  */
  int exact_given ;	/* Whether exact was given.  */
  int max_semphy_iterations_given ;	/* Whether max-semphy-iterations was given.  */
  int max_bbl_iterations_given ;	/* Whether max-bbl-iterations was given.  */
  int dont_use_NJ_given ;	/* Whether dont-use-NJ was given.  */
  int minimum_improvement_given ;	/* Whether minimum-improvement was given.  */
  int maxDistance_given ;	/* Whether maxDistance was given.  */
  int seed_given ;	/* Whether seed was given.  */

} ;

int cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* _cmdline_h */
