#include "evaluateCharacterFreq.h"

vector<MDOUBLE> evaluateCharacterFreq(const sequenceContainer1G & sc) {
	vector<MDOUBLE> charFreq(sc.getAlphabet()->size(),0.0);
	sequenceContainer1G::constTaxaIterator tIt;
	sequenceContainer1G::constTaxaIterator tItEnd;
	tIt.begin(sc);
	tItEnd.end(sc);
	while (tIt!= tItEnd) {
		sequence::constIterator sIt;
		sequence::constIterator sItEnd;
		sIt.begin(*tIt);
		sItEnd.end(*tIt);
		while (sIt != sItEnd) {
			if ((*sIt >= 0) && (*sIt <charFreq.size())) ++charFreq[(*sIt)];
			++sIt;
		}
		++tIt;
	}
	MDOUBLE sumA = 0;
	int i=0;
	for (i=0; i < charFreq.size(); ++i) {
        sumA+=charFreq[i] ;
	}
	for (i=0; i < charFreq.size(); ++i) {
		charFreq[i] /= sumA;
	}

	// CORRECT SO THAT THERE ARE NO ZERO FREQUENCIES.
	// ALL FREQS THAT WERE ZERO ARE CHANGED
	MDOUBLE sumB=0;
	for (i=0; i < charFreq.size(); ++i) {
        if (charFreq[i]==0) charFreq[i] = 0.00001 ;
		else sumB +=charFreq[i];
	}
	for (i=0; i < charFreq.size(); ++i) {
		if (charFreq[i] != 0.00001) charFreq[i] /= sumB;
	}

	return charFreq;
}
