#include "uniformDistribution.h"


uniformDistribution::uniformDistribution(MDOUBLE epsilon, MDOUBLE lowerBound, MDOUBLE upperBound) :distribution()
{
	m_globalRate=1.0;
	setUniformParameters(epsilon, lowerBound, upperBound);
}


uniformDistribution::uniformDistribution(const uniformDistribution& other) : 
	m_rates(other.m_rates),
	m_ratesProb(other.m_ratesProb),
	m_globalRate(other.m_globalRate),
	m_epsilon(other.m_epsilon),
	m_upperBound(other.m_upperBound),
	m_lowerBound(other.m_lowerBound)
{
}



void uniformDistribution::setUniformParameters(MDOUBLE epsilon, MDOUBLE lowerBound, MDOUBLE upperBound)
{
	m_epsilon = epsilon;
	m_upperBound = upperBound;
	m_lowerBound = lowerBound;
	
	int number_of_categories = (static_cast<int>((upperBound - lowerBound) / epsilon)) + 1;
	m_rates.clear();
	m_rates.resize(number_of_categories);
	m_ratesProb.erase(m_ratesProb.begin(),m_ratesProb.end());
	m_ratesProb.resize(number_of_categories, 1.0/number_of_categories);
	
	for (int i = 0; i < number_of_categories; ++i) 
	{
		m_rates[i] = m_lowerBound + (m_epsilon * i);
	}
}

