#include "mainSemphy.h"
#include "wtime.h"
#include "mpiWrap.h"

MDOUBLE BBL_para_time;
MDOUBLE Semphy_para_time;
MDOUBLE BBL_time;
MDOUBLE Semphy_time;


int main(int argc, char* argv[])
{
#ifdef _MPI
	pnlMpiInit(argc, argv);
#endif
	
	timer_start(0);
	mainSemphyNew(argc,argv);
	timer_stop(0);

#ifdef _MPI
	pnlMpiFinalize();
	if (_my_rank == 0)
	{
		printf ("\nBBL parallel and total time: %.2fs, %.2fs\n", BBL_para_time, BBL_time);
		printf ("Semphy parallel and total time: %.2fs, %.2fs\n", Semphy_para_time, Semphy_time);
		printf ("Total time: %.2fs\n", timer_read(0));
	}
#else
	printf ("\nBBL parallel and total time: %.2fs, %.2fs\n", BBL_para_time, BBL_time);
	printf ("Semphy parallel and total time: %.2fs, %.2fs\n", Semphy_para_time, Semphy_time);
	printf ("Total time: %.2fs\n", timer_read(0));
#endif
	
	//system("PAUSE");
	return 0;
}
