#ifndef ___MAIN_SEMPHY_NEW
#define ___MAIN_SEMPHY_NEW

#include "alphabet.h"
#include "definitions.h"
#include "sequenceContainer1G.h"
#include "stochasticProcess.h"
#include "treeInterface.h"
#include "nucleotide.h"
#include "amino.h"
#include "uniDistribution.h"
#include "gammaDistribution.h"
#include "readDatMatrix.h"
#include "aaJC.h"
#include "nucJC.h"
#include "hky.h"
#include "trivialAccelerator.h"
#include "chebyshevAccelerator.h"
#include "phylipFormat.h"
#include "maseFormat.h"
#include "fastaFormat.h"
#include "clustalFormat.h"
#include "molphyFormat.h"
#include "cmdline.h"

#include <iostream>

using namespace std;
using namespace treeInterface;


class mainSemphyNew {
public:
	explicit mainSemphyNew(int argc, char* argv[]);
	virtual ~mainSemphyNew(){}
private:
	void getSEMPHY_startingParameters(int argc, char* argv[],
								   alphabet* alphP,
								   sequenceContainer1G& sc,
								   tree* & myet,
								   vector<char> * idNotToSwap,
								   stochasticProcess& sp,
								   string& outputFileName,
								   int & numberOfRandomStart,
								   bool & doSemphyStep,
								   int & maxNumberOfBBLiterations);
void printSemphyTitle(ostream & out) {
	out<<"*******************************************************************************"<<endl;
	out<<"SEMPHY: A Structural EM Algorithm for Phylogenetic Inference                  "<<endl;
	out<<"for information, please send email to semphy@cs.huji.ac.il                    "<<endl;
	out<<"*******************************************************************************"<<endl;
	out<<endl;
}
};


#endif


