#ifndef ___SEMPHY_STEP
#define ___SEMPHY_STEP

#include "suffStatComponent.h"
#include "semphyDistance.h"
#include "rearangeTree.h"
#include "minSpanTree.h"
#include "treeInterface.h"
#include "sequenceContainer1G.h"
#include "computePijComponent.h"
#include "stochasticProcess.h"
using namespace treeInterface;

class semphyStep {
public:
	explicit semphyStep(
		  tree& et,
		  const sequenceContainer1G& sc,
		  const stochasticProcess& sp,
		  const computePijGam& pij0,
		  const suffStatGlobalGam& cup,
		  const suffStatGlobalGam& cdown,
		  const bool useApproxCounts,
		  const vector<MDOUBLE>& cprobAtEachPos,
		  const VVdouble & posteriorRateProbAtEachPos, //CODE_RED
		  const suffStatGlobalGam& computeMarginal,
				const Vdouble *weights,
				const MDOUBLE toll);

  void doNothing(void) const {};
				      

private:

	void computeSemphyStep();
//	void fillCpijUpDownExactMarginalProbAtEachPos();
	semphyDistance* computeQmatrix(const Vdouble* weight);
	MDOUBLE computeQstart(const semphyDistance* inSemDist) const;

	tree& _et;
	const sequenceContainer1G& _sc;
	const stochasticProcess& _sp;
	const computePijGam& _pij0;
	const suffStatGlobalGam& _cup;
	const suffStatGlobalGam& _cdown;
	const bool _useApproxCounts;
	const vector<MDOUBLE>& _cprobAtEachPos;
	const VVdouble & _posteriorRateProbAtEachPos; // CODE_RED
	const suffStatGlobalGam& _computeMarginal;
	const Vdouble *_weights;
	const MDOUBLE _toll;

	// ouput to log file functions...
	void maybePrintPenaltyTableAndStartingTree(const VVdouble& penetlyTable) const;
	void maybePrintDistanceBetweenNodesTable(const semphyDistance* inSemDist) const;
	void maybePrintSpanTreeListAndQAfterSpanTree(const rearrangeTree::pairSet& inSet,const MDOUBLE score) const;
	void maybePrintTheTreeAfterRearrangeTree() const;
	void maybePrintQspanMinusQinit(const MDOUBLE qpan, const MDOUBLE qstart) const;
	void maybePrintTheTreeAfterCorrectToCanonialForm() const;

};

#endif

