
//#define _MPI
#ifdef _MPI

#include "mpi.h"
#include "mpi_errno.h"

PNL_API extern int	_my_rank, _num_procs;
PNL_API extern int	_namelen;
PNL_API extern char	_processor_name[MPI_MAX_PROCESSOR_NAME];
PNL_API extern int	_version, _subversion;

PNL_API extern int	nTotalCases;

PNL_API void pnlMpiInit(int argc, char * argv[]);
PNL_API void pnlMpiFinalize();

#define MPI_REMARK	printf
// #define snprintf	_snprintf
#define MPI_WARNING	printf

char * _RetCode2String(int code);

#define MPI_CALL(Func)                                                          {			                                                          	int _status = Func;			                                     	if (_status != MPI_SUCCESS)		                                    	{					                                       		char _warnMsg[256];		                                   		snprintf(_warnMsg, 255, 	                                		"MPI Function %s failed at %s %d ErrCode (%d): %s\n",				#Func, __FILE__, __LINE__, _status, 			               		_RetCode2String(_status));				              		MPI_WARNING(_warnMsg);					        	}								        }

#endif

